Index: trip-planner/src/main/java/finki/diplomska/tripplanner/models/dto/PlannerDto.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/models/dto/PlannerDto.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/models/dto/PlannerDto.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -10,10 +10,8 @@
     private String name;
     private String description;
-    private List<Long> locationList;
 
-    public PlannerDto(String name, String description, List<Long> locationList) {
+    public PlannerDto(String name, String description) {
         this.name = name;
         this.description = description;
-        this.locationList = locationList;
     }
 }
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/models/dto/PlannerLocationDto.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/models/dto/PlannerLocationDto.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/models/dto/PlannerLocationDto.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -0,0 +1,17 @@
+package finki.diplomska.tripplanner.models.dto;
+
+import lombok.Data;
+
+@Data
+public class PlannerLocationDto {
+    private Long locationId;
+    private Long plannerId;
+
+    public PlannerLocationDto() {
+    }
+
+    public PlannerLocationDto(Long locationId, Long plannerId) {
+        this.locationId = locationId;
+        this.plannerId = plannerId;
+    }
+}
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/repository/jpa/JpaLocationRepository.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/repository/jpa/JpaLocationRepository.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/repository/jpa/JpaLocationRepository.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -77,3 +77,9 @@
             "GROUP BY location.id_location ORDER BY CASE location.priority WHEN 'high' THEN 1 WHEN 'medium' THEN 2 WHEN 'low' THEN 3 END", nativeQuery = true)
     List<Location> findLocationsFromRegionForm(@Param("regionId") Long regionId, @Param("companionId") Long companionId, @Param("categoryIds") List<Long> categoryIds);
+
+    @Query(value = "SELECT * " +
+            "FROM locations AS l " +
+            "WHERE l.id_location IN " +
+            "(SELECT pl.id_location FROM planners_contain AS pl WHERE pl.id_planner = :plannerId)", nativeQuery = true)
+    List<Location> getAllLocationsForPlanner(@Param("plannerId") Long plannerId);
 }
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/service/LocationService.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/service/LocationService.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/service/LocationService.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -3,4 +3,6 @@
 
 import finki.diplomska.tripplanner.models.Location;
+import finki.diplomska.tripplanner.models.Planner;
+import finki.diplomska.tripplanner.models.dto.PlannerLocationDto;
 
 import java.util.List;
@@ -17,3 +19,6 @@
     List<Location> findLocationsFromCityForm(Long cityId, Long companionId, Long lengthOfStay, String categoryIds);
     List<Location> findLocationsFromRegionForm(Long regionId, Long companionId, Long lengthOfStay, String categoryIds);
+    Location addLocationToPlanner(PlannerLocationDto plannerLocationDto);
+    List<Location> getAllLocationsForPlanner(Long plannerId);
+
 }
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/service/PlannerService.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/service/PlannerService.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/service/PlannerService.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -14,5 +14,4 @@
         List<Planner> getAllPlaners();
         Optional<Planner> findById(Long id);
-        Planner addLocationToPlanner(Long plannerId, Long locationId);
         Planner editPlannerWithRequestParams(Long id, String description, String name, List<Location> locationList);
         Optional<Planner> newPlanner(PlannerDto plannerDto);
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/service/impl/LocationServiceImpl.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/service/impl/LocationServiceImpl.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/service/impl/LocationServiceImpl.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -2,6 +2,9 @@
 
 import finki.diplomska.tripplanner.models.Location;
+import finki.diplomska.tripplanner.models.Planner;
+import finki.diplomska.tripplanner.models.dto.PlannerLocationDto;
 import finki.diplomska.tripplanner.models.exceptions.LocationNotFoundException;
 import finki.diplomska.tripplanner.repository.jpa.JpaLocationRepository;
+import finki.diplomska.tripplanner.repository.jpa.JpaPlannerRepository;
 import finki.diplomska.tripplanner.service.LocationService;
 import org.springframework.stereotype.Service;
@@ -15,7 +18,9 @@
 
     private final JpaLocationRepository locationRepository;
+    private final JpaPlannerRepository plannerRepository;
 
-    public LocationServiceImpl(JpaLocationRepository locationRepository) {
+    public LocationServiceImpl(JpaLocationRepository locationRepository, JpaPlannerRepository plannerRepository) {
         this.locationRepository = locationRepository;
+        this.plannerRepository = plannerRepository;
     }
 
@@ -150,3 +155,18 @@
     }
 
+    @Override
+    public Location addLocationToPlanner(PlannerLocationDto plannerLocationDto) {
+        Location location = this.locationRepository.findById(plannerLocationDto.getLocationId())
+                .orElseThrow(() -> new LocationNotFoundException(plannerLocationDto.getLocationId()));
+        Planner planner = this.plannerRepository.getById(plannerLocationDto.getPlannerId());
+        planner.getLocationList().add(location);
+        return this.locationRepository.save(location);
+    }
+
+    @Override
+    public List<Location> getAllLocationsForPlanner(Long plannerId) {
+        return this.locationRepository.getAllLocationsForPlanner(plannerId);
+    }
+
+
 }
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/service/impl/PlannerServiceImpl.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/service/impl/PlannerServiceImpl.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/service/impl/PlannerServiceImpl.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -22,10 +22,8 @@
     private final JpaPlannerRepository plannerRepository;
     private final JpaLocationRepository locationRepository;
-    private final LocationService locationService;
 
-    public PlannerServiceImpl(JpaPlannerRepository plannerRepository, JpaLocationRepository locationRepository, LocationService locationService) {
+    public PlannerServiceImpl(JpaPlannerRepository plannerRepository, JpaLocationRepository locationRepository) {
         this.plannerRepository = plannerRepository;
         this.locationRepository = locationRepository;
-        this.locationService = locationService;
     }
 
@@ -40,12 +38,4 @@
     }
 
-    @Override
-    public Planner addLocationToPlanner(Long plannerId, Long locationId) {
-        Location location = this.locationService.findById(locationId)
-                .orElseThrow(() -> new LocationNotFoundException(locationId));
-        Planner planner = this.plannerRepository.getById(plannerId);
-        planner.getLocationList().add(location);
-        return this.plannerRepository.save(planner);
-    }
 
     @Override
@@ -84,5 +74,5 @@
         planner.setName(plannerDto.getName());
         planner.setDescription(plannerDto.getDescription());
-
+/*
         List<Location> locationList  = new ArrayList<>();
         for(Long location : plannerDto.getLocationList()){
@@ -92,4 +82,6 @@
         }
         planner.setLocationList(locationList);
+
+ */
         return Optional.of(this.plannerRepository.save(planner));
     }
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/web/rest/LocationRestController.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/web/rest/LocationRestController.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/web/rest/LocationRestController.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -2,4 +2,5 @@
 
 import finki.diplomska.tripplanner.models.Location;
+import finki.diplomska.tripplanner.models.dto.PlannerLocationDto;
 import finki.diplomska.tripplanner.service.LocationService;
 import finki.diplomska.tripplanner.service.PlannerService;
@@ -50,3 +51,13 @@
         return this.locationService.findLocationsFromRegionForm(regionId, companionId,lengthOfStay, categoryIds);
     }
+
+    @PutMapping(value = "/add-location")
+    public Location addLocationToPlanner(@RequestBody PlannerLocationDto plannerLocationDto){
+        return this.locationService.addLocationToPlanner(plannerLocationDto);
+    }
+
+    @GetMapping(value = "/planner/locations")
+    public List<Location> getAllLocationsForPlanner (@RequestParam Long plannerId){
+        return this.locationService.getAllLocationsForPlanner(plannerId);
+    }
 }
Index: trip-planner/src/main/java/finki/diplomska/tripplanner/web/rest/PlannerRestController.java
===================================================================
--- trip-planner/src/main/java/finki/diplomska/tripplanner/web/rest/PlannerRestController.java	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/main/java/finki/diplomska/tripplanner/web/rest/PlannerRestController.java	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -71,7 +71,4 @@
     }
 
-    @PutMapping(value = "/add-location")
-    public Planner addLocationToPlanner(@RequestParam Long lid, @RequestParam Long pid){
-        return this.plannerService.addLocationToPlanner(lid, pid);
-    }
+
 }
Index: trip-planner/src/test/api.http
===================================================================
--- trip-planner/src/test/api.http	(revision 6a8023106281cf8cc9e4dc316984fdb52cdcf8e2)
+++ trip-planner/src/test/api.http	(revision ceaed429447854991cde276cd74df8d5dc9a2009)
@@ -52,5 +52,10 @@
 ###
 PUT http://localhost:8080/api/add-location
+Content-Type: application/json
+
+{"plannerId": 1, "locationId": 2}
+
+###
+GET http://localhost:8080/api/planner/locations?plannerId=1
 Content-Type: application/x-www-form-urlencoded
 
-lid=1&pid=1
